 /******************\
 * Casio Fx - 9860 * 
 * Project: Game   * 
 * Name: BOXED     * 
 * Author: Eiyeron * 
 * File: game.c    * 
 * Year: 2011      * 
 \******************/

#include "fxlib.h"
#include "MonochromeLib.h"
#include "levels.h"
#include "game.h"
#include "util.h"

void Game()
{
//Sprites
	unsigned char mur[] = {0xFF, 0xBD, 0xFF, 0xFF, 0xFF, 0xFF, 0xBD, 0xFF};
	unsigned char caisse[] = {0x7E, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x7E};
	unsigned char dot[] = {0x00, 0x3C, 0x5E, 0x7E, 0x7E, 0x7E, 0x3C, 0x00 };
	unsigned char caissemise[] = {0x7E, 0x81, 0x99, 0xBD, 0xBD, 0x99, 0x81, 0x7E};
	unsigned char persof[] = {0x18, 0x18, 0x00, 0x5A, 0x3C, 0x18, 0x3C, 0x42};
	unsigned char persor[] = {0x18, 0x18, 0x00, 0x1A, 0x1C, 0x18, 0x18, 0x0C};
	unsigned char persol[] = {0x18, 0x18, 0x00, 0x58, 0x38, 0x18, 0x18, 0x30};
//Variables
	unsigned int LvlGame = 1;
	unsigned char PosX = 0;
	unsigned char PosY = 0;
	char quit = 0;
	unsigned char CaissesMises = 0;
	unsigned int *key;
	Level * niveau = LoadLevel(LvlGame);
	unsigned int Steps;//Player's moves
	unsigned int Moves;//Boxes's moves
//Source
	Bkey_Set_RepeatTime(5,5); //TEMP
	while(LvlGame <= LVL_MAX)//while there is levels left.
	{
	//Start of the level
		Moves = 0;
		Steps = 0;
		PosX = niveau->StartX;
		PosY = niveau->StartY;
		CaissesMises = niveau->placedBox;		
		Bdisp_AllClr_VRAM();
		DrawLevel(niveau);
		ML_bmp_8_xor(persof, 8 * PosX, 8 * PosY);
		Bdisp_PutDisp_DD();
		while(!quit)
		{
			GetKey(key); 
			
			if( *key == KEY_CTRL_EXIT)
				quit = 3; // sortie et quit
			if( *key == KEY_CTRL_F1)
			{	
				while(IsKeyDown(KEY_CTRL_F1));
				quit = 2;//Retry
			}
			if( *key == KEY_CTRL_F2)//Stats
			{	
				Stats("====Statistiques=====", LvlGame, Steps, Moves, CaissesMises, niveau->NumBox);
				DrawLevel(niveau);
				ML_bmp_8_xor(persof, 8 * PosX, 8 * PosY);
				Bdisp_PutDisp_DD();

			}	
			if( *key == KEY_CTRL_F5 && LvlGame > 1)
				quit = -1; //Lv-1
			if( *key == KEY_CTRL_F6 && LvlGame < LVL_MAX)
				quit = 1; //Lv+1
			
			if( *key == KEY_CTRL_LEFT|| *key == KEY_CTRL_RIGHT || *key == KEY_CTRL_UP || *key == KEY_CTRL_DOWN)
			// if arrow pressed
				{
					if( *key == KEY_CTRL_LEFT && PosX > 0 && niveau->map[PosY * niveau->width + PosX - 1] != MUR)
					// if left and if can move to left( not limit of map or if not a wall or a box)
					{
						if(niveau->map[PosY * niveau->width + PosX - 1] == VIDE||niveau->map[PosY * niveau->width + PosX - 1] == DOT)
						// if there is a button or not
							{
								ML_rectangle(8 * PosX, 8 * PosY, 8 * PosX + 7, 8 * PosY + 7,0,WHITE,WHITE);
								if(niveau->map[PosY * niveau->width + PosX] == DOT)
									ML_bmp_8_or(dot, 8 * PosX, 8 * PosY);
								PosX--;
								ML_bmp_8_xor(persol, 8 * PosX, 8 * PosY);
								Bdisp_PutDisp_DD();
								Steps++;
							}
							
							
						else if(PosX > 1 && (niveau->map[PosY * niveau->width + PosX - 1] == CAISSE || niveau->map[PosY * niveau->width + PosX - 1] == CAISSEMISE) && (niveau->map[PosY * niveau->width + PosX - 2] == VIDE) ||niveau->map[PosY * niveau->width + PosX - 2] == DOT)
						//if there is a box, and if it can move
							{
								ML_rectangle(8 * PosX - 15, 8 * PosY, 8 * PosX + 7, 8 * PosY + 7,0,WHITE,WHITE);
								
								if(niveau->map[PosY * niveau->width + PosX - 1] == CAISSEMISE)
									{
									ML_bmp_8_or(dot, 8 * (PosX - 1), 8 * PosY);
									CaissesMises--;
									}
								
								niveau->map[PosY * niveau->width + PosX - 2] += CAISSE;
									if(niveau->map[PosY * niveau->width + PosX - 2] == CAISSE)
										ML_bmp_8_or(caisse, 8 * (PosX - 2), 8 * PosY);
									else if(niveau->map[PosY * niveau->width + PosX - 2] == CAISSEMISE)
										{
										ML_bmp_8_or(caissemise, 8 * (PosX - 2), 8 * PosY);
										CaissesMises++;
										}
								niveau->map[PosY * niveau->width + PosX - 1] -= CAISSE;
										
								if(niveau->map[PosY * niveau->width + PosX] == DOT)
									ML_bmp_8_or(dot, 8 * PosX, 8 * PosY);

								PosX--;
								ML_bmp_8_xor(persol, 8 * PosX, 8 * PosY);
								Bdisp_PutDisp_DD();
								Moves++;
								Steps++;
							}
						
					}
					
					else if( *key == KEY_CTRL_RIGHT && PosX <niveau->width && niveau->map[PosY * niveau->width + PosX + 1] != MUR) //same system on the others directions
					{
						if(niveau->map[PosY * niveau->width + PosX + 1] == VIDE||niveau->map[PosY * niveau->width + PosX + 1] == DOT)
							{
								ML_rectangle(8 * PosX, 8 * PosY, 8 * PosX + 7, 8 * PosY + 7,0,WHITE,WHITE);
								if(niveau->map[PosY * niveau->width + PosX] == DOT)
									ML_bmp_8_or(dot, 8 * PosX, 8 * PosY);
								PosX++;
								ML_bmp_8_xor(persor, 8 * PosX, 8 * PosY);
								Bdisp_PutDisp_DD();
								Steps++;
							}
							
							
						else if(PosX < niveau->width - 1 && (niveau->map[PosY * niveau->width + PosX + 1] == CAISSE || niveau->map[PosY * niveau->width + PosX + 1] == CAISSEMISE) && (niveau->map[PosY * niveau->width + PosX + 2] == VIDE) ||niveau->map[PosY * niveau->width + PosX + 2] == DOT)
							{
								ML_rectangle(8 * PosX, 8 * PosY, 8 * PosX + 23, 8 * PosY + 7,0,WHITE,WHITE);
								
								if(niveau->map[PosY * niveau->width + PosX + 1] == CAISSEMISE)
									{
									ML_bmp_8_or(dot, 8 * (PosX + 1), 8 * PosY);
									CaissesMises--;
									}
								niveau->map[PosY * niveau->width + PosX + 2] += CAISSE;
									if(niveau->map[PosY * niveau->width + PosX + 2] == CAISSE)
										ML_bmp_8_or(caisse, 8 * (PosX + 2), 8 * PosY);
									else if(niveau->map[PosY * niveau->width + PosX + 2] == CAISSEMISE)
										{
										ML_bmp_8_or(caissemise, 8 * (PosX + 2), 8 * PosY);
										CaissesMises++;
										}
								niveau->map[PosY * niveau->width + PosX + 1] -= CAISSE;
										
								if(niveau->map[PosY * niveau->width + PosX] == DOT)
									ML_bmp_8_or(dot, 8 * PosX, 8 * PosY);

								PosX++;
								ML_bmp_8_xor(persor, 8 * PosX, 8 * PosY);
								Bdisp_PutDisp_DD();
								Moves++;
								Steps++;
							}
						
					}
				
					else if( *key == KEY_CTRL_UP && PosY >0 && niveau->map[(PosY - 1) * niveau->width + PosX] != MUR)
					{
						if(niveau->map[(PosY - 1) * niveau->width + PosX] == VIDE||niveau->map[(PosY - 1) * niveau->width + PosX] == DOT)
							{
								ML_rectangle(8 * PosX, 8 * PosY, 8 * PosX + 7, 8 * PosY + 7,0,WHITE,WHITE);
								if(niveau->map[PosY * niveau->width + PosX] == DOT)
									ML_bmp_8_or(dot, 8 * PosX, 8 * PosY);
								PosY--;
								ML_bmp_8_xor(persof, 8 * PosX, 8 * PosY);
								Bdisp_PutDisp_DD();
								Steps++;
							}
							
							
						else if(PosY >1 &&(niveau->map[(PosY - 1) * niveau->width + PosX] == CAISSE || niveau->map[(PosY - 1) * niveau->width + PosX] == CAISSEMISE)&& (niveau->map[(PosY - 2) * niveau->width + PosX] == VIDE) ||niveau->map[(PosY - 2) * niveau->width + PosX] == DOT)
							{
								ML_rectangle(8 * PosX, 8 * PosY - 15, 8 * PosX + 7, 8 * PosY + 7,0,WHITE,WHITE);
								
								if(niveau->map[(PosY - 1) * niveau->width + PosX] == CAISSEMISE)
									{
									ML_bmp_8_or(dot, 8 * PosX, 8 * (PosY - 1));
									CaissesMises--;
									}
								niveau->map[(PosY - 2) * niveau->width + PosX] += CAISSE;
								if(niveau->map[(PosY - 2) * niveau->width + PosX] == CAISSE)
									ML_bmp_8_or(caisse, 8 * PosX, 8 * (PosY - 2));
								else if(niveau->map[(PosY - 2) * niveau->width + PosX] == CAISSEMISE)
									{
									ML_bmp_8_or(caissemise, 8 * PosX, 8 * (PosY - 2));
									CaissesMises++;
									}

								niveau->map[(PosY - 1) * niveau->width + PosX] -= CAISSE;
										
								if(niveau->map[PosY * niveau->width + PosX] == DOT)
									ML_bmp_8_or(dot, 8 * PosX, 8 * PosY);

								PosY--;
								ML_bmp_8_xor(persof, 8 * PosX, 8 * PosY);
								Bdisp_PutDisp_DD();
								Moves++;
								Steps++;
							}
						
					}
					
					else if( *key == KEY_CTRL_DOWN && PosY < niveau->height - 1 && niveau->map[(PosY + 1) * niveau->width + PosX] != MUR)
					{
						if(niveau->map[(PosY + 1) * niveau->width + PosX] == VIDE||niveau->map[(PosY + 1) * niveau->width + PosX] == DOT)
							{
								ML_rectangle(8 * PosX, 8 * PosY, 8 * PosX + 7, 8 * PosY + 7,0,WHITE,WHITE);
								if(niveau->map[PosY * niveau->width + PosX] == DOT)
									ML_bmp_8_or(dot, 8 * PosX, 8 * PosY);
								PosY++;
								ML_bmp_8_xor(persof, 8 * PosX, 8 * PosY);
								Bdisp_PutDisp_DD();
								Steps++;
							}
							
							
						else if(PosX >1 &&(niveau->map[(PosY + 1) * niveau->width + PosX] == CAISSE || niveau->map[(PosY + 1) * niveau->width + PosX] == CAISSEMISE)&& (niveau->map[(PosY + 2) * niveau->width + PosX] == VIDE) ||niveau->map[(PosY + 2) * niveau->width + PosX] == DOT)
							{
								ML_rectangle(8 * PosX, 8 * PosY , 8 * PosX + 7, 8 * PosY + 23,0,WHITE,WHITE);
								
								if(niveau->map[(PosY + 1) * niveau->width + PosX] == CAISSEMISE)
									{
									ML_bmp_8_or(dot, 8 * PosX, 8 * (PosY + 1));
									CaissesMises--;
									}
								
								niveau->map[(PosY + 2) * niveau->width + PosX] += CAISSE;
								if(niveau->map[(PosY + 2) * niveau->width + PosX] == CAISSE)
									ML_bmp_8_or(caisse, 8 * PosX, 8 * (PosY + 2));
								else if(niveau->map[(PosY + 2) * niveau->width + PosX] == CAISSEMISE)
									{
									ML_bmp_8_or(caissemise, 8 * PosX, 8 * (PosY + 2));
									CaissesMises++;
									}
								niveau->map[(PosY + 1) * niveau->width + PosX] -= CAISSE;
										
								if(niveau->map[PosY * niveau->width + PosX] == DOT)
									ML_bmp_8_or(dot, 8 * PosX, 8 * PosY);

								PosY++;
								ML_bmp_8_xor(persof, 8 * PosX, 8 * PosY);
								Bdisp_PutDisp_DD();
								Moves++;
								Steps++;
							}
						
					}
					while(IsKeyDown(KEY_CTRL_LEFT) || IsKeyDown(KEY_CTRL_RIGHT) || IsKeyDown(KEY_CTRL_UP) || IsKeyDown(KEY_CTRL_DOWN) );
				}

		if(CaissesMises == niveau->NumBox)// if the level is complete, goto next level
			quit++;
		RTC_GetTicks();// To get a time regular loop
		}
		if (quit == 1)//Next level
			{
			if (CaissesMises == niveau->NumBox)
				Stats("====Niveau Termine===", LvlGame, Steps, Moves, CaissesMises, niveau->NumBox);
			LvlGame++;
			niveau = ChangeLevel(niveau, LvlGame);
			quit = 0;
			}
		else if (quit == 2)//Qetry
			{
			niveau = ChangeLevel(niveau, LvlGame);
			quit = 0;
			}
		else if(quit == 3)//Quit
			{
			while(IsKeyDown(KEY_CTRL_EXIT));
			quit = 0;
			return;
			}
		else if (quit == -1)//Retry
			{
			LvlGame--;
			niveau = ChangeLevel(niveau, LvlGame);
			quit = 0;
			}
		}
}

void DrawLevel(Level * lvl)//Draw the whole map
{
	unsigned char mur[] = {0xFF, 0xBD, 0xFF, 0xFF, 0xFF, 0xFF, 0xBD, 0xFF};
	unsigned char caisse[] = {0x7E, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x7E};
	unsigned char dot[] = {0x00, 0x3C, 0x5E, 0x7E, 0x7E, 0x7E, 0x3C, 0x00};
	unsigned char caissemise[] = {0x7E, 0x81, 0x99, 0xBD, 0xBD, 0x99, 0x81, 0x7E};
	char i = 0;
	char j = 0;
	
	for(j = 0; j < lvl->height; j++)
	{
		for(i = 0; i < lvl->width; i++)
		{
			switch(lvl->map[j * lvl->width + i])
			{
				case 1:
				ML_bmp_8_or(mur, i * 8, j * 8);
				break;
				
				case 2:
				ML_bmp_8_or(dot, i * 8,j * 8);
				break;
				
				case 3:
				ML_bmp_8_or(caisse, i * 8,j * 8);
				break;
				
				case 5:
				ML_bmp_8_or(caissemise, i * 8, j * 8);
				break;
				
			}
		}
	}
}

void Stats(char* title ,unsigned int Lvl, unsigned int Steps, unsigned int Moves, unsigned char Placed, unsigned char NBoxes)
{
	char temp[16];
	Bdisp_AllClr_VRAM();
	locate(1,1);
	Print(title);
	
	locate(1,2);
	Print("- Level ");
	uint2str(temp, Lvl);
	Print(temp);	

	locate(1,3);
	Print("- Steps: ");
	uint2str(temp, Steps);
	Print(temp);
	
	locate(1,4);
	Print("- Moves: ");
	uint2str(temp, Moves);
	Print(temp);
	
	locate(1,5);
	Print("- Placed : ");
	uchar2str(temp, Placed);
	Print(temp);
	uint2str(temp, NBoxes);
	Print("/");
	Print(temp);
		
	locate(1,8);
	Print("=====Press [EXE]=====");
	
	Bdisp_PutDisp_DD();
	while(IsKeyUp(KEY_CTRL_EXE));
	while(IsKeyDown(KEY_CTRL_EXE));
	Bdisp_AllClr_VRAM();
	
}