 /*****************\
 * Casio Fx - 9860*
 * Project: Game  *
 * Name: BOXED    *
 * Author: Eiyeron*
 * File: levels.c *
 * Year: 2011     *
 \*****************/

#include <stdlib.h> //for malloc, free and memcpy
#include "levels.h"

/**
Level has a simple structure:

Level*
	->map is a unsigned char 1D array
	->width
	->height, the both is indcaotrs of the map dimensions
	->StartX
	->StartY, the both indicate where the player will begin
	->placedBox, to indicate how many boxes is already placed at the begin of game
	->numBox is the number of boxes
So numBox may be not equal to the number of buttons, you can have 3 buttons and need only 2 buttons activated...
m is just a temporary array to copy the level to level->map
*/


Level* LoadLevel(unsigned int n)
{
	Level* level;
	level = malloc(sizeof(Level));
	
	
	if(n == 1)
		{
			unsigned char m[8*8] = {
			0,0,M,M,M,M,M,0,
			M,M,M,0,0,0,M,0,
			M,0,B,0,M,0,M,M,
			M,0,M,0,0,D,0,M,
			M,0,0,0,0,M,0,M,
			M,M,0,M,0,0,0,M,
			0,M,0,0,0,M,M,M,
			0,M,M,M,M,M,0,0
			};
			level->StartX = 3;
			level->StartY = 6;
			level->width = 8;
			level->height = 8;
			level->placedBox = 0;
			level->NumBox = 1;
			level->map = malloc(level->height * level->width);
			memcpy(level->map, m, level->height * level->width);

		}
	else if(n == 2)
		{
			unsigned char m[7*6] = {
			M,M,M,M,0,0,
			M,0,0,M,0,0,
			M,0,0,M,0,0,
			M,0,0,M,M,M,
			M,0,B,B,0,M,
			M,D,0,0,D,M,
			M,M,M,M,M,1
			};
			level->StartX = 2;
			level->StartY = 3;
			level->width = 6;
			level->height = 7;
			level->placedBox = 0;
			level->NumBox = 2;
			level->map = malloc(level->height * level->width);
			memcpy(level->map, m, level->height * level->width);

		}
	else if(n == 3)
		{
			unsigned char m[7*8] = {
			0,0,M,M,M,M,M,0,
			M,M,M,0,0,0,M,M,
			M,0,0,B,D,0,0,M,
			M,0,0,D,B,D,0,M,
			M,M,M,0,P,B,0,M,
			0,0,M,0,0,0,M,M,
			0,0,M,M,M,M,M,0		
			};
			level->StartX = 5;
			level->StartY = 1;
			level->width = 8;
			level->height = 7;
			level->placedBox = 1;
			level->NumBox = 4;
			level->map = malloc(level->height * level->width);
			memcpy(level->map, m, level->height * level->width);

		}
	else if(n == 4)
		{

			unsigned char m[7*6] = {
			M,M,M,M,0,0,
			M,D,0,M,0,0,
			M,0,0,M,M,M,
			M,0,B,0,0,M,
			M,0,B,D,0,M,
			M,0,0,M,M,M,
			M,M,M,M,0,0
			};
			level->StartX = 2;
			level->StartY = 1;
			level->width = 6;
			level->height = 7;
			level->placedBox = 0;
			level->NumBox = 2;
			level->map = malloc(level->height * level->width);
			memcpy(level->map, m, level->height * level->width);
	}
	else if(n == 5)
		{

			unsigned char m[7*10] = {
			0,0,0,M,M,M,M,M,M,0,
			0,M,M,M,0,0,0,0,M,0,
			M,M,D,0,B,M,M,0,M,M,
			M,D,D,B,0,B,0,0,0,M,
			M,D,D,0,B,0,B,0,M,M,
			M,M,M,M,M,0,0,0,M,0,
			0,0,0,0,0,M,M,M,M,0
			};
			level->StartX = 8;
			level->StartY = 3;
			level->width = 10;
			level->height = 7;
			level->placedBox = 0;
			level->NumBox = 5;
			level->map = malloc(level->height * level->width);
			memcpy(level->map, m, level->height * level->width);

		}
	else if(n == 6)
		{
			unsigned char m[8*11] = {
			0,0,0,0,0,0,M,M,M,M,M,
			0,0,0,0,0,0,M,D,0,0,M,
			0,0,0,0,0,0,M,D,M,0,M,
			M,M,M,M,M,M,M,D,M,0,M,
			M,0,0,0,B,0,B,0,B,0,M,
			M,0,M,0,M,0,M,0,M,M,M,
			M,0,0,0,0,0,0,0,M,0,0,
			M,M,M,M,M,M,M,M,M,0,0
			};
			level->StartX = 2;
			level->StartY = 4;
			level->width = 11;
			level->height = 8;
			level->placedBox = 0;
			level->NumBox = 3;
			level->map = malloc(level->height * level->width);
			memcpy(level->map, m, level->height * level->width);

		}
	else if(n == 7)
		{
			unsigned char m[7*10] = {
			0,M,M,M,M,M,M,M,M,0,
			M,M,D,D,M,0,0,0,M,0,
			M,0,D,D,M,0,B,0,M,M,
			M,0,0,0,B,0,0,B,0,M,
			M,M,B,M,M,M,0,0,0,M,
			0,M,0,0,0,0,0,M,M,M,
			0,M,M,M,M,M,M,M,0,0
			};
			level->StartX = 2;
			level->StartY = 3;
			level->width = 10;
			level->height = 7;
			level->placedBox = 0;
			level->NumBox = 4;
			level->map = malloc(level->height * level->width);
			memcpy(level->map, m, level->height * level->width);

		}
	else if(n == 8)
		{
			unsigned char m[7*8] = {
			0,0,0,M,M,M,M,0,
			M,M,M,M,0,0,M,0,
			M,0,B,D,D,D,M,M,
			M,0,0,B,D,D,0,M,
			M,M,M,B,B,B,0,M,
			0,0,M,0,0,0,0,M,
			0,0,M,M,M,M,M,1
			};
			level->StartX = 1;
			level->StartY = 3;
			level->width = 8;
			level->height = 7;
			level->placedBox = 0;
			level->NumBox = 5;
			level->map = malloc(level->height * level->width);
			memcpy(level->map, m, level->height * level->width);

		}
	else if(n == 9)
		{
			unsigned char m[6*12] = {
			0,M,M,M,M,M,M,M,M,M,M,0,
			M,M,0,0,0,0,M,0,0,0,M,M,
			M,0,0,B,D,D,D,D,0,B,0,M,
			M,0,B,0,M,M,M,M,B,0,0,M,
			M,M,0,0,M,0,0,M,0,0,0,M,
			0,M,M,M,M,0,0,M,M,M,M,1
			};
			level->StartX = 8;
			level->StartY = 1;
			level->width = 12;
			level->height = 6;
			level->placedBox = 0;
			level->NumBox = 4;
			level->map = malloc(level->height * level->width);
			memcpy(level->map, m, level->height * level->width);

		}
	
	else if(n == 10)
		{
			unsigned char m[8*8] = {
			M,M,M,M,M,M,M,M,
			M,D,0,0,0,B,0,M,
			M,D,B,0,0,M,0,M,
			M,D,M,0,M,0,0,M,
			M,M,M,0,M,0,M,M,
			0,M,0,B,0,0,M,0,
			0,M,0,0,M,M,M,0,
			0,M,M,M,M,0,0,0
			};	
			level->StartX = 2;
			level->StartY = 6;
			level->width = 8;
			level->height = 8;
			level->placedBox = 0;
			level->NumBox = 3;
			level->map = malloc(level->height * level->width);
			memcpy(level->map, m, level->height * level->width);

		}
	else if(n == 11)
		{
			unsigned char m[8*7] = {
			M,M,M,M,M,M,M,
			M,0,0,0,0,0,M,
			M,0,D,B,D,0,M,
			M,0,B,D,B,0,M,
			M,0,D,B,D,0,M,
			M,0,B,D,B,0,M,
			M,0,0,D,0,0,M,
			M,M,M,M,M,M,M
			};
			level->StartX = 3;
			level->StartY = 5;
			level->width = 7;
			level->height = 8;
			level->placedBox = 0;
			level->NumBox = 6;
			level->map = malloc(level->height * level->width);
			memcpy(level->map, m, level->height * level->width);
		
		}
	else if(n == 12)
		{
			unsigned char m[7*9] = {
			M,M,M,M,0,M,M,M,M,
			M,0,0,M,M,M,0,0,M,
			M,0,B,0,P,0,B,0,M,
			M,0,0,0,D,0,0,0,M,
			M,M,M,0,D,B,M,M,M,
			0,0,M,0,D,0,M,0,0,
			M,0,M,M,M,M,M,0,M
			};
			level->StartX = 4;
			level->StartY = 3;
			level->width = 9;
			level->height = 7;
			level->placedBox = 1;
			level->NumBox = 4;
			level->map = malloc(level->height * level->width);
			memcpy(level->map, m, level->height * level->width);

		}
	else if(n == 13)
		{
			unsigned char m[8*10] = {
			0,0,0,0,0,M,M,M,M,0,
			0,0,M,M,M,M,0,0,M,0,
			0,0,M,D,D,0,0,0,M,0,
			M,M,M,0,B,0,M,0,M,M,
			M,0,0,B,0,M,D,D,0,M,
			M,0,B,0,0,0,B,0,0,M,
			M,M,M,M,0,0,M,M,M,M,
			0,0,0,M,M,M,M,0,0,0
			};
			level->StartX = 5;
			level->StartY = 3;
			level->width = 10;
			level->height = 8;
			level->placedBox = 0;
			level->NumBox = 4;
			level->map = malloc(level->height * level->width);
			memcpy(level->map, m, level->height * level->width);

		}
	else if(n == 14)
		{
			unsigned char m[8*7] = {
			0,0,0,M,M,M,M,
			0,M,M,M,0,0,M,
			M,M,0,0,B,0,M,
			M,0,D,B,0,0,M,
			M,0,D,P,0,M,M,
			M,0,D,B,0,M,0,
			M,M,0,0,M,M,0,
			0,M,M,M,M,0,0
			};
			level->StartX = 3;
			level->StartY = 2;
			level->width = 7;
			level->height = 8;
			level->placedBox = 1;
			level->NumBox = 4;
			level->map = malloc(level->height * level->width);
			memcpy(level->map, m, level->height * level->width);

		}
	else if(n == 15)//hard, a garder en fin de jeu
		{
			unsigned char m[8*16] = {
			M,M,M,M,M,M,M,M,0,0,M,M,M,M,M,M,
			M,M,M,0,0,0,0,M,M,M,M,M,0,0,0,M,
			M,0,0,0,M,M,0,0,M,M,M,0,B,0,0,M,
			M,0,0,0,0,0,M,0,M,M,0,B,0,0,M,M,
			M,M,0,M,M,0,D,D,D,D,P,0,0,M,M,0,
			M,0,B,0,0,0,B,M,M,M,0,0,M,M,0,0,
			M,0,0,0,M,0,0,M,M,M,M,M,M,0,0,0,
			M,M,M,M,M,M,M,M,0,0,M,M,0,0,0,0
			};
			level->StartX =  2;
			level->StartY =  3;
			level->width = 16;
			level->height = 8;
			level->placedBox = 1;
			level->NumBox = 5;
			level->map = malloc(level->height * level->width);
			memcpy(level->map, m, level->height * level->width);
			
		}
	else
		{	
			free(level);
			return NULL;
		}
		

	return level;
}

Level* ChangeLevel(Level* level, unsigned int n)
{
	free(level->map); //level and level->map are mallocated
	free(level);
	level = LoadLevel(n); // and we are again! :p
	return level;
}